%bcond_with    camomile

Summary:        Internationalization library for OCaml
Name:           ocaml-gettext
Version:        0.4.2
Release:        5%{?dist}

License:        LGPLv2+ with exceptions
URL:            https://github.com/gildor478/ocaml-gettext
Source0:        https://github.com/gildor478/%{name}/archive/v%{version}.tar.gz
Patch3000:      ocaml-gettext-ocaml5.patch
Patch3001:      ocaml-gettext-camomile2.patch

BuildRequires: make automake autoconf libxslt libxml2 chrpath docbook-style-xsl
BuildRequires: ocaml >= 4.03.1 ocaml-fileutils-devel >= 0.4.4
BuildRequires: ocaml-dune-devel ocaml-cppo ocaml-compiler-libs ocaml-ocamldoc

%if %{with camomile}
BuildRequires:  ocaml-camomile-devel >= 0.8.6-3
BuildRequires:  ocaml-camomile-data
Requires:       ocaml-camomile-data
%endif

%global __ocaml_requires_opts -i Asttypes -i Parsetree
%global __ocaml_provides_opts -i Pr_gettext


%description
ocaml-gettext provides enough service to build a internationalized program. It comes with :

- a pure Ocaml implementation, based on Camomile,
- an alternative implementation with a binding to GNU gettext library,
- ocaml-gettext a tool to extract strings from Ocaml source.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-fileutils-devel >= 0.4.4


%description    devel
This package provides libraries for developing applications that use %{name}.


%if %{with camomile}
%package        camomile
Summary:        Parts of %{name} which depend on Camomile
Requires:       %{name} = %{version}-%{release}


%description    camomile
The %{name}-camomile package contains the parts of %{name} which
depend on Camomile.


%package        camomile-devel
Summary:        Development files for %{name}-camomile
Requires:       %{name}-devel = %{version}-%{release}
Requires:       %{name}-camomile = %{version}-%{release}


%description    camomile-devel
This package provides libraries for developing applications that use
%{name}-camomile.
%endif


%prep
%autosetup -p1

sed -i -e 's/batteries//' test/dune
sed -i -e 's/batteries//' test/test-stub/dune

%if %{without camomile}
rm -f gettext-camomile.opam
rm -r src/lib/gettext-camomile
rm -r test/test-camomile
sed -i -e 's/camomile//' `find -name dune`
%endif


%build
make build



%install
mkdir -p %{buildroot}%{_libdir}/ocaml
mkdir -p %{buildroot}%{_bindir}
dune install --destdir=%{buildroot}

rm -rf %{buildroot}/usr/doc

%if %{without camomile}
rm -rf %{buildroot}/%{_libdir}/ocaml/gettext-camomile
%endif


%files
%license LICENSE.txt
%{_libdir}/ocaml/gettext
%{_libdir}/ocaml/gettext-stub
%exclude %{_libdir}/ocaml/gettext/*.cmxa
%exclude %{_libdir}/ocaml/gettext/*/*.a
%exclude %{_libdir}/ocaml/gettext/*/*.cmxa
%exclude %{_libdir}/ocaml/gettext/*/*.cmx
%exclude %{_libdir}/ocaml/gettext-stub/*.a
%exclude %{_libdir}/ocaml/gettext-stub/*.cmxa
%exclude %{_libdir}/ocaml/gettext-stub/*.cmx
%exclude %{_libdir}/ocaml/gettext/*/*.ml
%exclude %{_libdir}/ocaml/gettext/*/*.mli
%exclude %{_libdir}/ocaml/gettext-stub/*.ml
%{_libdir}/ocaml/stublibs/*.so


%files devel
%doc README.md CHANGES.md THANKS TODO.md
%{_bindir}/ocaml-gettext
%{_bindir}/ocaml-xgettext
%{_libdir}/ocaml/gettext/*.cmxa
%{_libdir}/ocaml/gettext/*/*.a
%{_libdir}/ocaml/gettext/*/*.cmxa
%{_libdir}/ocaml/gettext/*/*.cmx
%{_libdir}/ocaml/gettext-stub/*.a
%{_libdir}/ocaml/gettext-stub/*.cmxa
%{_libdir}/ocaml/gettext-stub/*.cmx
%{_libdir}/ocaml/gettext/*/*.ml
%{_libdir}/ocaml/gettext/*/*.mli
%{_libdir}/ocaml/gettext-stub/*.ml
%{_mandir}/man1/ocaml-gettext.1*
%{_mandir}/man1/ocaml-xgettext.1*
%{_mandir}/man5/ocaml-gettext.5*


%if %{with camomile}
%files camomile
%license LICENSE.txt
%{_libdir}/ocaml/gettext-camomile
%exclude %{_libdir}/ocaml/gettext-camomile/*.a
%exclude %{_libdir}/ocaml/gettext-camomile/*.cmxa
%exclude %{_libdir}/ocaml/gettext-camomile/*.cmx
%exclude %{_libdir}/ocaml/gettext-camomile/*.mli


%files camomile-devel
%doc README.md
%{_libdir}/ocaml/gettext-camomile/*.a
%{_libdir}/ocaml/gettext-camomile/*.cmxa
%{_libdir}/ocaml/gettext-camomile/*.cmx
%{_libdir}/ocaml/gettext-camomile/*.mli
%endif


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.2-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 11 2023 rockerzhu <rockerzhu@tencent.com> - 0.4.2-4
- Build with ocaml 5.0.

* Tue Aug 08 2023 cunshunxia <cunshunxia@tencent.com> - 0.4.2-3
- Rebuilt for ocaml-findlib 1.9.6

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.2-2
- Rebuilt for OpenCloudOS Stream 23.05

* Mon Apr 03 2023 cunshunxia <cunshunxia@tencent.com> - 0.4.2-1
- initial build
